﻿<AML>
 <Item type="Method" id="6BA939CB412D4B7A810F0701B61B07C0" action="add">
  <comments>2018-01-16--MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			sop_pl_excelfile_import
Created By/Company:		Chan 
Creation Date:			2019-02-05
Description:
    Reading from Excel and set to form properties.

Hooks:
	Type:	Form    :   sop_packing_list
	Event:	button1 ( onClick )
	
Revisions:
	Rev Date		Modified By			Description
	2017-11-25      MyoThet         Add 'sop_select_file' property for File Upload instead of top.aras.vault.SelectFile() method
	2018-01-16      MyoThet         Bind 'stk_part_number' from excel file
	2019-02-05		Chan		    set Method Template and update to get returning data from javascript method.
***************************************************************************** */
//debugger;
var item = document.thisItem;
var myInnovator = item.getInnovator();
var filepath = item.getProperty("sop_file_import");

/** Add 'sop_select_file' property for File Upload instead of top.aras.vault.SelectFile() method **/
var sop_select_file = item.getProperty("sop_select_file", "NULL");
var select_file_item = document.thisItem.getItemsByXPath("//Item[@type='File']");

if (select_file_item) {

    var file_count = select_file_item.getItemCount();
    var selected_file = select_file_item.getItemByIndex(file_count - 1);
    var CheckIn = selected_file.apply();
    if (CheckIn.isError()) {
        top.aras.AlertError("Error in File Item CheckIn.");
        return false;
    }
}
var fileid = CheckIn.getProperty("id");
var fileName = CheckIn.getProperty("filename", "");

var result = null;

var params = "<fileName>" + fileName + "</fileName>" + "<fileid>" + fileid + "</fileid>";
result = myInnovator.applyMethod('SOP_Import_DeliveryOrderExcel', params);


if (result === null || result.isError()) {
    top.aras.AlertError(result.getErrorDetail());
    top.aras.AlertError("Error in Reading Excel File.");
    return false;
}

var method_result = result.getResult();
if (method_result.indexOf("ExceptionMessage") !== -1) {
    top.aras.AlertError(method_result);
    return false;
}

var result_count = result.getItemCount();
if (result_count > 0) {

    /*Get Packing List Details*/

    var result_detail = result.getRelationships("sop_packing_list_details");
    for (var i = 0; i < result_detail.getItemCount(); i++) {
        var excelData = result_detail.getItemByIndex(i);

        var PLDetail = myInnovator.newItem("sop_packing_list_details", "add");
        var stk_code = excelData.getProperty("stk_code");
        var stk_location = excelData.getProperty("stk_location");
        var stk_uom = excelData.getProperty("stk_uom");
        if (stk_code !== undefined) {
            var stock = myInnovator.getItemById("stk_stock_setup", stk_code);
            PLDetail.setPropertyItem("stk_code", stock);
        }
        if (stk_location !== undefined) {
            var location_item = myInnovator.getItemById("stk_location", stk_location);
            PLDetail.setPropertyItem("stk_location", location_item);
        }
        if (stk_uom !== undefined) {
            var uom = myInnovator.getItemById("stk_uom", stk_uom);
            PLDetail.setPropertyItem("stk_uom", uom);
        }
        PLDetail.setProperty("stk_part_number", excelData.getProperty("stk_part_number", ""));
        PLDetail.setProperty("stk_qty", excelData.getProperty("stk_qty"));
        PLDetail.setProperty("stk_description", excelData.getProperty("stk_description"));
        PLDetail.setProperty("sop_box_item", excelData.getProperty("sop_box_item"));
        PLDetail.setProperty("sop_po_item", excelData.getProperty("sop_po_item"));
        PLDetail.setProperty("sop_packlist_serialno", excelData.getProperty("sop_packlist_serialno"));
        PLDetail.setProperty("source_id", document.thisItem.getProperty("id"));
        document.thisItem.addRelationship(PLDetail);
        document.thisItem.setAttribute("isDirty", "1");

    }

    /*Get Packing List Details*/

    /*Get Packing List Box Info*/
    var getBoxInfo_detail = result.getRelationships("sop_packing_list_info");
    for (var i = 0; i < getBoxInfo_detail.getItemCount(); i++) {
        var boxData = getBoxInfo_detail.getItemByIndex(i);
        if (!boxData.isError()) {
            var plBox = myInnovator.newItem("sop_packing_list_info", "add");
            plBox.setProperty("sop_box_info", boxData.getProperty("sop_box_info"));
            plBox.setProperty("sop_measurement", boxData.getProperty("sop_measurement"));
            plBox.setProperty("source_id", document.thisItem.getProperty("id"));
            document.thisItem.addRelationship(plBox);
            document.thisItem.setAttribute("isDirty", "1");
        }
    }
    /*Get Packing List Box Info*/
} else {
    top.aras.AlertError("There is no data return from reading excel file.");
    return;
}

var PackingNo = result.getProperty("sop_packing_list_no");
myHandleItemChange("sop_po_reference", result.getProperty("sop_po_reference", ""));
myHandleItemChange("sop_country_of_origin", result.getProperty("sop_country_of_origin", ""));
myHandleItemChange("sop_incoterm", result.getProperty("sop_incoterm", ""));
myHandleItemChange("sop_brand", result.getProperty("sop_brand", ""));
myHandleItemChange("sop_consignee", result.getProperty("sop_consignee", ""));
myHandleItemChange("sop_consignee_contact", result.getProperty("sop_consignee_contact", ""));
myHandleItemChange("sop_ship_to", result.getProperty("sop_ship_to", ""));
myHandleItemChange("sop_ship_to_address", result.getProperty("sop_ship_to_address", ""));
myHandleItemChange("sop_consignee_address", result.getProperty("sop_consignee_address", ""));
myHandleItemChange("sop_date", result.getProperty("sop_date", ""));
myHandleItemChange("sop_so_no", result.getProperty("sop_so_no", ""));
myHandleItemChange("sop_order_no", result.getProperty("sop_order_no", ""));
myHandleItemChange("sop_commercial_no", result.getProperty("sop_commercial_no", ""));
myHandleItemChange("sop_project_no", result.getProperty("sop_project_no", ""));

var tabbar = parent.relationships.relTabbar;
var tabID = tabbar.GetTabId("PL Details");
parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);

function myHandleItemChange(property, value) {
    if (top.instance.document) {
        top.instance.handleItemChange(property, value);
    } else {
        top.frames[1].handleItemChange(property, value);
    }
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>sop_pl_excelfile_import</name>
 </Item>
</AML>